#include "app_flag.h"
#include "HAL.h"
/*******************************************************************************
 * Function Name  : SwitchImageFlag
 * Description    : лdataflashImageFlag,лIAP򽫸flagΪImageFlag_USER_PROGRAM_CALL_IAPת0λü
 * Input          : new_flagлImageFlag
 * Output         : none
 * Return         : none
 *******************************************************************************/
void SwitchImageFlag(UINT8 new_flag) {
    UINT16 i;
    UINT32 ver_flag;
    __attribute__((aligned(8)))        UINT8 block_buf[4];
    /* ȡһ */
    EEPROM_READ(OTA_DATAFLASH_ADD, (PUINT32 ) &block_buf[0], 4);
    if (block_buf[0] != new_flag) {
        /* һ */
        EEPROM_ERASE(OTA_DATAFLASH_ADD, EEPROM_PAGE_SIZE);

        /* ImageϢ */
        block_buf[0] = new_flag;

        /* DataFlash */
        EEPROM_WRITE(OTA_DATAFLASH_ADD, (PUINT32 ) &block_buf[0], 4);
    }
}

void jumpToIap(void)
{
    u32 irq_status;
    SwitchImageFlag(ImageFlag_USER_PROGRAM_CALL_IAP);
    SYS_DisableAllIrq( &irq_status );
    SYS_ResetExecute();
}
